{-# OPTIONS -fglasgow-exts -fallow-overlapping-instances -fallow-undecidable-instances #-}
-----------------------------------------------------------------------------
-- |
-- Maintainer  :  Alexandra Silva and Joost Visser
-- Stability   :  experimental
-- Portability :  portable
--
--
-----------------------------------------------------------------------------

module Data.HDB.FunctionalDependenciesHUnit where

import Data.HDB.CoddFish ()
import Data.HDB.FunctionalDependencies
import Data.HDB.NormalForms ()
import Data.HDB.Representation
import Data.HListExtras
import Test.HUnit

-----------------------------------------------------------------------------

main
  = runTestTT . TestList $ testList
  
labeledTest l t
  = TestLabel l (TestCase t)

testList
  = [labeledTest "isPrime" (
        do 
         assertEqual "Result should be False" False (booleanValue $ isPrime a'' h fds4)
         assertEqual "Result should be True" True (booleanValue $ isPrime ct all1 fds2)
         assertEqual "Result should be True" True (booleanValue $ isPrime s all1 fds2)
         assertEqual "Result should be True" True (booleanValue $ isPrime z all1 fds2))] 
-- Examples



-- Example 7.10/7.12 page 398 Ullman

ct = (attribute ) :: (Attribute String ()) 
s = (attribute ) :: (Attribute String HZero) 
z = (attribute ) :: (Attribute String One) 

all1 = ct .*. s .*. z .*. HNil
fds2 = (FD (ct .*. s .*. HNil) (z .*. HNil)) .*.
       (FD (z .*. HNil) (ct .*. HNil)) .*.  HNil


-- Example 7.14 page 402 Ullman
 
s' = (attribute ) :: (Attribute String ()) 
a'' = (attribute) :: (Attribute String HZero) 
i' = (attribute ) :: (Attribute String One) 
p' = (attribute ) :: (Attribute String Two) 

h = s' .*. a'' .*. i' .*. p' .*. HNil 

fds4 = (FD (s' .*. i' .*. HNil) (p' .*. HNil)) .*.
       (FD (s' .*. HNil) (a'' .*. HNil)) .*. HNil

