module Language.Gnumeric.Syntax where
import Language.Gnumeric.Formula

import Text.XML.HaXml.Xml2Haskell
import Char (isSpace)


{-Type decls-}

newtype Gmr'Names = Gmr'Names [Gmr'NameGroup] 		deriving (Eq,Show,Read)
data Gmr'NameGroup = Gmr'NameGroup Gmr'name Gmr'value Gmr'position
		   deriving (Eq,Show,Read)
newtype Gmr'position = Gmr'position String 		deriving (Eq,Show,Read)
data Gmr'Workbook = Gmr'Workbook Gmr'Workbook_Attrs
				 (Maybe Gmr'Version) (Maybe Gmr'Attributes) (Maybe Gmr'Summary)
				 [Gmr'DateConvention] (Maybe Gmr'SheetNameIndex) [Gmr'Names]
				 (Maybe Gmr'Style) Gmr'Geometry Gmr'Sheets (Maybe Gmr'UIData)
				 (Maybe Gmr'Calculation)
		  deriving (Eq,Show,Read)
data Gmr'Workbook_Attrs = Gmr'Workbook_Attrs
    { gmr'WorkbookXmlns'gmr :: (Maybe String)
    , gmr'WorkbookXmlns'xsi :: (Maybe String)
    , gmr'WorkbookXsi'schemaLocation :: (Maybe String)
    } deriving (Eq,Show,Read)
newtype Gmr'Attributes = Gmr'Attributes [Gmr'Attribute] 		deriving (Eq,Show,Read)
newtype Gmr'Summary = Gmr'Summary [Gmr'Item] 		deriving (Eq,Show,Read)
newtype Gmr'DateConvention = Gmr'DateConvention String 		deriving (Eq,Show,Read)
newtype Gmr'SheetNameIndex = Gmr'SheetNameIndex [Gmr'SheetName] 		deriving (Eq,Show,Read)
data Gmr'Geometry = Gmr'Geometry
    { gmr'GeometryWidth :: String
    , gmr'GeometryHeight :: String
    } deriving (Eq,Show,Read)
data Gmr'Version = Gmr'Version
    { gmr'VersionEpoch :: (Maybe String)
    , gmr'VersionMajor :: (Maybe String)
    , gmr'VersionMinor :: (Maybe String)
    , gmr'VersionFull :: (Maybe String)
    } deriving (Eq,Show,Read)
newtype Gmr'Sheets = Gmr'Sheets [Gmr'Sheet] 		deriving (Eq,Show,Read)
data Gmr'UIData = Gmr'UIData
    { gmr'UIDataSelectedTab :: String
    } deriving (Eq,Show,Read)
data Gmr'Calculation = Gmr'Calculation
    { gmr'CalculationManualRecalc :: (Maybe String)
    , gmr'CalculationEnableIteration :: (Maybe String)
    , gmr'CalculationMaxIterations :: (Maybe String)
    , gmr'CalculationIterationTolerance :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Attribute = Gmr'Attribute (Maybe Gmr'type)
				   (Maybe Gmr'name) (Maybe Gmr'value)
		   deriving (Eq,Show,Read)
data Gmr'Item = Gmr'Item Gmr'name (Maybe Gmr'val_string)
			 (Maybe Gmr'val_int)
	      deriving (Eq,Show,Read)
newtype Gmr'SheetName = Gmr'SheetName String 		deriving (Eq,Show,Read)
data Gmr'Sheet = Gmr'Sheet Gmr'Sheet_Attrs Gmr'Name
			   (Maybe Gmr'MaxCol) (Maybe Gmr'MaxRow) Gmr'Zoom [Gmr'Names]
			   (Maybe Gmr'PrintInformation) Gmr'Styles Gmr'Cols Gmr'Rows
			   Gmr'Selections (Maybe Gmr'Objects) Gmr'Cells
			   (Maybe Gmr'MergedRegions) Gmr'SheetLayout [Gmr'Solver]
			   [Gmr'Scenarios]
	       deriving (Eq,Show,Read)
data Gmr'Sheet_Attrs = Gmr'Sheet_Attrs
    { gmr'SheetDisplayFormulas :: String
    , gmr'SheetHideZero :: String
    , gmr'SheetHideGrid :: String
    , gmr'SheetHideColHeader :: String
    , gmr'SheetHideRowHeader :: String
    , gmr'SheetDisplayOutlines :: String
    , gmr'SheetOutlineSymbolsBelow :: String
    , gmr'SheetOutlineSymbolsRight :: String
    , gmr'SheetTabColor :: (Maybe String)
    } deriving (Eq,Show,Read)
newtype Gmr'name = Gmr'name String 		deriving (Eq,Show,Read)
newtype Gmr'type = Gmr'type String 		deriving (Eq,Show,Read)
newtype Gmr'value = Gmr'value String 		deriving (Eq,Show,Read)
newtype Gmr'val_string = Gmr'val_string String 		deriving (Eq,Show,Read)
newtype Gmr'val_int = Gmr'val_int String 		deriving (Eq,Show,Read)
newtype Gmr'Name = Gmr'Name String 		deriving (Eq,Show,Read)
newtype Gmr'MaxCol = Gmr'MaxCol String 		deriving (Eq,Show,Read)
newtype Gmr'MaxRow = Gmr'MaxRow String 		deriving (Eq,Show,Read)
newtype Gmr'Zoom = Gmr'Zoom String 		deriving (Eq,Show,Read)
data Gmr'PrintInformation = Gmr'PrintInformation Gmr'Margins
						 Gmr'Scale Gmr'vcenter Gmr'hcenter Gmr'grid
						 Gmr'even_if_only_styles Gmr'monochrome Gmr'draft
						 Gmr'titles (Maybe Gmr'repeat_top)
						 (Maybe Gmr'repeat_left) Gmr'order Gmr'orientation
						 Gmr'Header Gmr'Footer (Maybe Gmr'paper)
			  deriving (Eq,Show,Read)
newtype Gmr'Styles = Gmr'Styles [Gmr'StyleRegion] 		deriving (Eq,Show,Read)
data Gmr'Cols = Gmr'Cols Gmr'Cols_Attrs [Gmr'ColInfo]
	      deriving (Eq,Show,Read)
data Gmr'Cols_Attrs = Gmr'Cols_Attrs
    { gmr'ColsDefaultSizePts :: String
    } deriving (Eq,Show,Read)
data Gmr'Rows = Gmr'Rows Gmr'Rows_Attrs [Gmr'RowInfo]
	      deriving (Eq,Show,Read)
data Gmr'Rows_Attrs = Gmr'Rows_Attrs
    { gmr'RowsDefaultSizePts :: String
    } deriving (Eq,Show,Read)
data Gmr'Selections = Gmr'Selections Gmr'Selections_Attrs
				     [Gmr'Selection]
		    deriving (Eq,Show,Read)
data Gmr'Selections_Attrs = Gmr'Selections_Attrs
    { gmr'SelectionsCursorCol :: String
    , gmr'SelectionsCursorRow :: String
    } deriving (Eq,Show,Read)
data Gmr'Objects = Gmr'Objects [Gmr'SheetObjectBonobo]
			       [Gmr'CellComment] [Gmr'SheetObjectFilled] [Gmr'Button]
			       [Gmr'Checkbox] [Gmr'Frame] [Gmr'Label]
		 deriving (Eq,Show,Read)
newtype Gmr'Cells = Gmr'Cells [Gmr'Cell] 		deriving (Eq,Show,Read)
newtype Gmr'MergedRegions = Gmr'MergedRegions [Gmr'Merge] 		deriving (Eq,Show,Read)
data Gmr'Solver = Gmr'Solver Gmr'Solver_Attrs [Gmr'Constr]
		deriving (Eq,Show,Read)
data Gmr'Solver_Attrs = Gmr'Solver_Attrs
    { gmr'SolverTargetCol :: (Maybe String)
    , gmr'SolverTargetRow :: (Maybe String)
    , gmr'SolverProblemType :: String
    , gmr'SolverInputs :: String
    , gmr'SolverMaxTime :: (Maybe String)
    , gmr'SolverMaxIter :: (Maybe String)
    , gmr'SolverNonNeg :: (Maybe String)
    , gmr'SolverDiscr :: (Maybe String)
    , gmr'SolverAutoScale :: (Maybe String)
    , gmr'SolverShowIter :: (Maybe String)
    , gmr'SolverAnswerR :: (Maybe String)
    , gmr'SolverSensitivityR :: (Maybe String)
    , gmr'SolverLimitsR :: (Maybe String)
    , gmr'SolverPerformR :: (Maybe String)
    , gmr'SolverProgramR :: (Maybe String)
    } deriving (Eq,Show,Read)
newtype Gmr'Scenarios = Gmr'Scenarios String 		deriving (Eq,Show,Read)
data Gmr'SheetLayout = Gmr'SheetLayout Gmr'SheetLayout_Attrs
				       (Maybe Gmr'FreezePanes)
		     deriving (Eq,Show,Read)
data Gmr'SheetLayout_Attrs = Gmr'SheetLayout_Attrs
    { gmr'SheetLayoutTopLeft :: String
    } deriving (Eq,Show,Read)
data Gmr'Margins = Gmr'Margins Gmr'top Gmr'bottom Gmr'left
			       Gmr'right Gmr'header Gmr'footer
		 deriving (Eq,Show,Read)
data Gmr'Scale = Gmr'Scale
    { gmr'ScaleType :: String
    , gmr'ScalePercentage :: (Maybe String)
    , gmr'ScaleCols :: (Maybe String)
    , gmr'ScaleRows :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'vcenter = Gmr'vcenter
    { gmr'vcenterValue :: String
    } deriving (Eq,Show,Read)
data Gmr'hcenter = Gmr'hcenter
    { gmr'hcenterValue :: String
    } deriving (Eq,Show,Read)
data Gmr'grid = Gmr'grid
    { gmr'gridValue :: String
    } deriving (Eq,Show,Read)
data Gmr'even_if_only_styles = Gmr'even_if_only_styles
    { gmr'even_if_only_stylesValue :: String
    } deriving (Eq,Show,Read)
data Gmr'monochrome = Gmr'monochrome
    { gmr'monochromeValue :: String
    } deriving (Eq,Show,Read)
data Gmr'draft = Gmr'draft
    { gmr'draftValue :: String
    } deriving (Eq,Show,Read)
data Gmr'titles = Gmr'titles
    { gmr'titlesValue :: String
    } deriving (Eq,Show,Read)
data Gmr'repeat_top = Gmr'repeat_top
    { gmr'repeat_topValue :: String
    } deriving (Eq,Show,Read)
data Gmr'repeat_left = Gmr'repeat_left
    { gmr'repeat_leftValue :: String
    } deriving (Eq,Show,Read)
newtype Gmr'order = Gmr'order String 		deriving (Eq,Show,Read)
newtype Gmr'orientation = Gmr'orientation String 		deriving (Eq,Show,Read)
data Gmr'Header = Gmr'Header
    { gmr'HeaderLeft :: String
    , gmr'HeaderMiddle :: String
    , gmr'HeaderRight :: String
    } deriving (Eq,Show,Read)
data Gmr'Footer = Gmr'Footer
    { gmr'FooterLeft :: String
    , gmr'FooterMiddle :: String
    , gmr'FooterRight :: String
    } deriving (Eq,Show,Read)
newtype Gmr'paper = Gmr'paper String 		deriving (Eq,Show,Read)
data Gmr'StyleRegion = Gmr'StyleRegion Gmr'StyleRegion_Attrs
				       Gmr'Style
		     deriving (Eq,Show,Read)
data Gmr'StyleRegion_Attrs = Gmr'StyleRegion_Attrs
    { gmr'StyleRegionStartCol :: String
    , gmr'StyleRegionStartRow :: String
    , gmr'StyleRegionEndCol :: String
    , gmr'StyleRegionEndRow :: String
    } deriving (Eq,Show,Read)
data Gmr'ColInfo = Gmr'ColInfo
    { gmr'ColInfoNo :: String
    , gmr'ColInfoUnit :: String
    , gmr'ColInfoMarginA :: String
    , gmr'ColInfoMarginB :: String
    , gmr'ColInfoHardSize :: (Maybe String)
    , gmr'ColInfoHidden :: (Maybe String)
    , gmr'ColInfoCollapsed :: (Maybe String)
    , gmr'ColInfoOutlineLevel :: (Maybe String)
    , gmr'ColInfoCount :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'RowInfo = Gmr'RowInfo
    { gmr'RowInfoNo :: String
    , gmr'RowInfoUnit :: String
    , gmr'RowInfoMarginA :: String
    , gmr'RowInfoMarginB :: String
    , gmr'RowInfoHardSize :: (Maybe String)
    , gmr'RowInfoHidden :: (Maybe String)
    , gmr'RowInfoCollapsed :: (Maybe String)
    , gmr'RowInfoOutlineLevel :: (Maybe String)
    , gmr'RowInfoCount :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Selection = Gmr'Selection
    { gmr'SelectionStartCol :: String
    , gmr'SelectionStartRow :: String
    , gmr'SelectionEndCol :: String
    , gmr'SelectionEndRow :: String
    } deriving (Eq,Show,Read)
data Gmr'SheetObjectBonobo = Gmr'SheetObjectBonobo
    { gmr'SheetObjectBonoboObjectBound :: String
    , gmr'SheetObjectBonoboObjectOffset :: String
    , gmr'SheetObjectBonoboObjectAnchorType :: String
    , gmr'SheetObjectBonoboDirection :: Gmr'SheetObjectBonobo_Direction
    } deriving (Eq,Show,Read)
data Gmr'SheetObjectBonobo_Direction = Gmr'SheetObjectBonobo_Direction_MINUS
				        |  Gmr'SheetObjectBonobo_Direction_0  | 
				       Gmr'SheetObjectBonobo_Direction_1  | 
				       Gmr'SheetObjectBonobo_Direction_16  | 
				       Gmr'SheetObjectBonobo_Direction_17
				     deriving (Eq,Show,Read)
data Gmr'CellComment = Gmr'CellComment
    { gmr'CellCommentAuthor :: String
    , gmr'CellCommentText :: String
    , gmr'CellCommentObjectBound :: String
    , gmr'CellCommentObjectOffset :: String
    , gmr'CellCommentObjectAnchorType :: String
    , gmr'CellCommentDirection :: Gmr'CellComment_Direction
    } deriving (Eq,Show,Read)
data Gmr'CellComment_Direction = Gmr'CellComment_Direction_MINUS
				  |  Gmr'CellComment_Direction_0  |  Gmr'CellComment_Direction_1  | 
				 Gmr'CellComment_Direction_16  |  Gmr'CellComment_Direction_17
			       deriving (Eq,Show,Read)
data Gmr'SheetObjectFilled = Gmr'SheetObjectFilled
    { gmr'SheetObjectFilledOutlineColor :: String
    , gmr'SheetObjectFilledFillColor :: String
    , gmr'SheetObjectFilledType :: Gmr'SheetObjectFilled_Type
    , gmr'SheetObjectFilledWidth :: String
    , gmr'SheetObjectFilledArrowShapeA :: (Maybe String)
    , gmr'SheetObjectFilledArrowShapeB :: (Maybe String)
    , gmr'SheetObjectFilledArrowShapeC :: (Maybe String)
    , gmr'SheetObjectFilledObjectBound :: String
    , gmr'SheetObjectFilledObjectOffset :: String
    , gmr'SheetObjectFilledObjectAnchorType :: String
    , gmr'SheetObjectFilledDirection :: Gmr'SheetObjectFilled_Direction
    } deriving (Eq,Show,Read)
data Gmr'SheetObjectFilled_Type = Gmr'SheetObjectFilled_Type_1  | 
				  Gmr'SheetObjectFilled_Type_2  |  Gmr'SheetObjectFilled_Type_101
				   |  Gmr'SheetObjectFilled_Type_102
				deriving (Eq,Show,Read)
data Gmr'SheetObjectFilled_Direction = Gmr'SheetObjectFilled_Direction_MINUS
				        |  Gmr'SheetObjectFilled_Direction_0  | 
				       Gmr'SheetObjectFilled_Direction_1  | 
				       Gmr'SheetObjectFilled_Direction_16  | 
				       Gmr'SheetObjectFilled_Direction_17
				     deriving (Eq,Show,Read)
data Gmr'Button = Gmr'Button
    { gmr'ButtonLabel :: String
    , gmr'ButtonObjectBound :: String
    , gmr'ButtonObjectOffset :: String
    , gmr'ButtonObjectAnchorType :: String
    , gmr'ButtonDirection :: Gmr'Button_Direction
    } deriving (Eq,Show,Read)
data Gmr'Button_Direction = Gmr'Button_Direction_MINUS  | 
			    Gmr'Button_Direction_0  |  Gmr'Button_Direction_1  | 
			    Gmr'Button_Direction_16  |  Gmr'Button_Direction_17
			  deriving (Eq,Show,Read)
data Gmr'Checkbox = Gmr'Checkbox
    { gmr'CheckboxLabel :: String
    , gmr'CheckboxValue :: String
    , gmr'CheckboxInput :: String
    , gmr'CheckboxObjectBound :: String
    , gmr'CheckboxObjectOffset :: String
    , gmr'CheckboxObjectAnchorType :: String
    , gmr'CheckboxDirection :: Gmr'Checkbox_Direction
    } deriving (Eq,Show,Read)
data Gmr'Checkbox_Direction = Gmr'Checkbox_Direction_MINUS  | 
			      Gmr'Checkbox_Direction_0  |  Gmr'Checkbox_Direction_1  | 
			      Gmr'Checkbox_Direction_16  |  Gmr'Checkbox_Direction_17
			    deriving (Eq,Show,Read)
data Gmr'Frame = Gmr'Frame
    { gmr'FrameLabel :: String
    , gmr'FrameObjectBound :: String
    , gmr'FrameObjectOffset :: String
    , gmr'FrameObjectAnchorType :: String
    , gmr'FrameDirection :: Gmr'Frame_Direction
    } deriving (Eq,Show,Read)
data Gmr'Frame_Direction = Gmr'Frame_Direction_MINUS  | 
			   Gmr'Frame_Direction_0  |  Gmr'Frame_Direction_1  | 
			   Gmr'Frame_Direction_16  |  Gmr'Frame_Direction_17
			 deriving (Eq,Show,Read)
data Gmr'Label = Gmr'Label
    { gmr'LabelLabel :: String
    , gmr'LabelObjectBound :: String
    , gmr'LabelObjectOffset :: String
    , gmr'LabelObjectAnchorType :: String
    , gmr'LabelDirection :: Gmr'Label_Direction
    } deriving (Eq,Show,Read)
data Gmr'Label_Direction = Gmr'Label_Direction_MINUS  | 
			   Gmr'Label_Direction_0  |  Gmr'Label_Direction_1  | 
			   Gmr'Label_Direction_16  |  Gmr'Label_Direction_17
			 deriving (Eq,Show,Read)
data Gmr'Cell = Gmr'Cell Gmr'Cell_Attrs String
	      deriving (Eq,Show,Read)
data Gmr'Cell_Attrs = Gmr'Cell_Attrs
    { gmr'CellCol :: String
    , gmr'CellRow :: String
    , gmr'CellExprID :: (Maybe String)
    , gmr'CellValueType :: (Maybe Gmr'Cell_ValueType)
    , gmr'CellValueFormat :: (Maybe String)
    , gmr'CellCols :: (Maybe String)
    , gmr'CellRows :: (Maybe String)
    , gmr'CellAst :: (Maybe Formula)
    } deriving (Eq,Show,Read)
data Gmr'Cell_ValueType = Gmr'Cell_ValueType_10  | 
			  Gmr'Cell_ValueType_20  |  Gmr'Cell_ValueType_30  | 
			  Gmr'Cell_ValueType_40  |  Gmr'Cell_ValueType_50  | 
			  Gmr'Cell_ValueType_60  |  Gmr'Cell_ValueType_70  | 
			  Gmr'Cell_ValueType_80
			deriving (Eq,Show,Read)
newtype Gmr'Merge = Gmr'Merge String 		deriving (Eq,Show,Read)
data Gmr'Constr = Gmr'Constr
    { gmr'ConstrLcol :: String
    , gmr'ConstrLrow :: String
    , gmr'ConstrRcol :: String
    , gmr'ConstrRrow :: String
    , gmr'ConstrCols :: String
    , gmr'ConstrRows :: String
    , gmr'ConstrType :: Gmr'Constr_Type
    } deriving (Eq,Show,Read)
data Gmr'Constr_Type = Gmr'Constr_Type_0  |  Gmr'Constr_Type_1  | 
		       Gmr'Constr_Type_2  |  Gmr'Constr_Type_4  |  Gmr'Constr_Type_8  | 
		       Gmr'Constr_Type_16
		     deriving (Eq,Show,Read)
data Gmr'FreezePanes = Gmr'FreezePanes
    { gmr'FreezePanesFrozenTopLeft :: String
    , gmr'FreezePanesUnfrozenTopLeft :: String
    } deriving (Eq,Show,Read)
data Gmr'top = Gmr'top
    { gmr'topPoints :: (Maybe String)
    , gmr'topPrefUnit :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'bottom = Gmr'bottom
    { gmr'bottomPoints :: (Maybe String)
    , gmr'bottomPrefUnit :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'left = Gmr'left
    { gmr'leftPoints :: (Maybe String)
    , gmr'leftPrefUnit :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'right = Gmr'right
    { gmr'rightPoints :: (Maybe String)
    , gmr'rightPrefUnit :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'header = Gmr'header
    { gmr'headerPoints :: (Maybe String)
    , gmr'headerPrefUnit :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'footer = Gmr'footer
    { gmr'footerPoints :: (Maybe String)
    , gmr'footerPrefUnit :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Style = Gmr'Style Gmr'Style_Attrs Gmr'Font
			   (Maybe Gmr'StyleBorder)
	       deriving (Eq,Show,Read)
data Gmr'Style_Attrs = Gmr'Style_Attrs
    { gmr'StyleHAlign :: (Maybe String)
    , gmr'StyleVAlign :: (Maybe String)
    , gmr'StyleWrapText :: (Maybe String)
    , gmr'StyleOrient :: (Maybe String)
    , gmr'StyleShade :: (Maybe String)
    , gmr'StyleIndent :: (Maybe String)
    , gmr'StyleFore :: (Maybe String)
    , gmr'StyleBack :: (Maybe String)
    , gmr'StylePatternColor :: (Maybe String)
    , gmr'StyleLocked :: (Maybe String)
    , gmr'StyleHidden :: (Maybe String)
    , gmr'StyleFormat :: String
    , gmr'StyleShrinkToFit :: (Maybe String)
    , gmr'StyleRotation :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Font = Gmr'Font Gmr'Font_Attrs String
	      deriving (Eq,Show,Read)
data Gmr'Font_Attrs = Gmr'Font_Attrs
    { gmr'FontUnit :: String
    , gmr'FontBold :: String
    , gmr'FontItalic :: String
    , gmr'FontUnderline :: String
    , gmr'FontStrikeThrough :: String
    } deriving (Eq,Show,Read)
data Gmr'StyleBorder = Gmr'StyleBorder Gmr'Top Gmr'Bottom Gmr'Left
				       Gmr'Right Gmr'Diagonal Gmr'Rev_Diagonal
		     deriving (Eq,Show,Read)
data Gmr'Top = Gmr'Top
    { gmr'TopStyle :: String
    , gmr'TopColor :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Bottom = Gmr'Bottom
    { gmr'BottomStyle :: String
    , gmr'BottomColor :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Left = Gmr'Left
    { gmr'LeftStyle :: String
    , gmr'LeftColor :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Right = Gmr'Right
    { gmr'RightStyle :: String
    , gmr'RightColor :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Diagonal = Gmr'Diagonal
    { gmr'DiagonalStyle :: String
    , gmr'DiagonalColor :: (Maybe String)
    } deriving (Eq,Show,Read)
data Gmr'Rev_Diagonal = Gmr'Rev_Diagonal
    { gmr'Rev_DiagonalStyle :: String
    , gmr'Rev_DiagonalColor :: (Maybe String)
    } deriving (Eq,Show,Read)


{-Instance decls-}

instance XmlContent Gmr'Names where
    fromElem (CElem (Elem "gmr:Names" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Names a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Names a) =
	[CElem (Elem "gmr:Names" [] (concatMap toElem a))]
instance XmlContent Gmr'NameGroup where
    fromElem (CElem (Elem "gmr:Name" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (Just (Gmr'NameGroup a b c), rest))
	      (definite fromElem "<gmr:position>" "gmr:Name" cb))
	   (definite fromElem "<gmr:value>" "gmr:Name" ca))
	(definite fromElem "<gmr:name>" "gmr:Name" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'NameGroup a b c) =
	[CElem (Elem "gmr:Name" [] (toElem a ++ toElem b ++
					 toElem c))]
instance XmlContent Gmr'position where
    fromElem (CElem (Elem "gmr:position" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'position a), rest))
	(definite fromText "text" "gmr:position" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'position a) =
	[CElem (Elem "gmr:position" [] (toText a))]
instance XmlContent Gmr'Workbook where
    fromElem (CElem (Elem "gmr:Workbook" as c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (\(g,cg)->
			     (\(h,ch)->
				(\(i,ci)->
				   (\(j,cj)->
				      (\(k,ck)->
					 (Just (Gmr'Workbook (fromAttrs as) a b c d e f g h i j
									    k), rest))
				      (fromElem cj))
				   (fromElem ci))
				(definite fromElem "<gmr:Sheets>" "gmr:Workbook" ch))
			     (definite fromElem "<gmr:Geometry>" "gmr:Workbook" cg))
			  (fromElem cf))
		       (many fromElem ce))
		    (fromElem cd))
		 (many fromElem cc))
	      (fromElem cb))
	   (fromElem ca))
	(fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Workbook as a b c d e f g h i j k) =
	[CElem (Elem "gmr:Workbook" (toAttrs as) (maybe [] toElem a ++
						  maybe [] toElem b ++ maybe [] toElem c ++
						  concatMap toElem d ++ maybe [] toElem e ++
						  concatMap toElem f ++ maybe [] toElem g ++
						  toElem h ++ toElem i ++ maybe [] toElem j ++
						  maybe [] toElem k))]
instance XmlAttributes Gmr'Workbook_Attrs where
    fromAttrs as =
	Gmr'Workbook_Attrs
	  { gmr'WorkbookXmlns'gmr = possibleA fromAttrToStr "xmlns:gmr" as
	  , gmr'WorkbookXmlns'xsi = possibleA fromAttrToStr "xmlns:xsi" as
	  , gmr'WorkbookXsi'schemaLocation = possibleA fromAttrToStr "xsi:schemaLocation" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "xmlns:gmr" (gmr'WorkbookXmlns'gmr v)
	, maybeToAttr toAttrFrStr "xmlns:xsi" (gmr'WorkbookXmlns'xsi v)
	, maybeToAttr toAttrFrStr "xsi:schemaLocation" (gmr'WorkbookXsi'schemaLocation v)
	]
instance XmlContent Gmr'Attributes where
    fromElem (CElem (Elem "gmr:Attributes" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Attributes a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Attributes a) =
	[CElem (Elem "gmr:Attributes" [] (concatMap toElem a))]
instance XmlContent Gmr'Summary where
    fromElem (CElem (Elem "gmr:Summary" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Summary a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Summary a) =
	[CElem (Elem "gmr:Summary" [] (concatMap toElem a))]
instance XmlContent Gmr'DateConvention where
    fromElem (CElem (Elem "gmr:DateConvention" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'DateConvention a), rest))
	(definite fromText "text" "gmr:DateConvention" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'DateConvention a) =
	[CElem (Elem "gmr:DateConvention" [] (toText a))]
instance XmlContent Gmr'SheetNameIndex where
    fromElem (CElem (Elem "gmr:SheetNameIndex" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'SheetNameIndex a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'SheetNameIndex a) =
	[CElem (Elem "gmr:SheetNameIndex" [] (concatMap toElem a))]
instance XmlContent Gmr'Geometry where
    fromElem (CElem (Elem "gmr:Geometry" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Geometry" (toAttrs as) [])]
instance XmlAttributes Gmr'Geometry where
    fromAttrs as =
	Gmr'Geometry
	  { gmr'GeometryWidth = definiteA fromAttrToStr "gmr:Geometry" "Width" as
	  , gmr'GeometryHeight = definiteA fromAttrToStr "gmr:Geometry" "Height" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Width" (gmr'GeometryWidth v)
	, toAttrFrStr "Height" (gmr'GeometryHeight v)
	]
instance XmlContent Gmr'Version where
    fromElem (CElem (Elem "gmr:Version" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Version" (toAttrs as) [])]
instance XmlAttributes Gmr'Version where
    fromAttrs as =
	Gmr'Version
	  { gmr'VersionEpoch = possibleA fromAttrToStr "Epoch" as
	  , gmr'VersionMajor = possibleA fromAttrToStr "Major" as
	  , gmr'VersionMinor = possibleA fromAttrToStr "Minor" as
	  , gmr'VersionFull = possibleA fromAttrToStr "Full" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Epoch" (gmr'VersionEpoch v)
	, maybeToAttr toAttrFrStr "Major" (gmr'VersionMajor v)
	, maybeToAttr toAttrFrStr "Minor" (gmr'VersionMinor v)
	, maybeToAttr toAttrFrStr "Full" (gmr'VersionFull v)
	]
instance XmlContent Gmr'Sheets where
    fromElem (CElem (Elem "gmr:Sheets" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Sheets a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Sheets a) =
	[CElem (Elem "gmr:Sheets" [] (concatMap toElem a))]
instance XmlContent Gmr'UIData where
    fromElem (CElem (Elem "gmr:UIData" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:UIData" (toAttrs as) [])]
instance XmlAttributes Gmr'UIData where
    fromAttrs as =
	Gmr'UIData
	  { gmr'UIDataSelectedTab = definiteA fromAttrToStr "gmr:UIData" "SelectedTab" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "SelectedTab" (gmr'UIDataSelectedTab v)
	]
instance XmlContent Gmr'Calculation where
    fromElem (CElem (Elem "gmr:Calculation" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Calculation" (toAttrs as) [])]
instance XmlAttributes Gmr'Calculation where
    fromAttrs as =
	Gmr'Calculation
	  { gmr'CalculationManualRecalc = possibleA fromAttrToStr "ManualRecalc" as
	  , gmr'CalculationEnableIteration = possibleA fromAttrToStr "EnableIteration" as
	  , gmr'CalculationMaxIterations = possibleA fromAttrToStr "MaxIterations" as
	  , gmr'CalculationIterationTolerance = possibleA fromAttrToStr "IterationTolerance" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "ManualRecalc" (gmr'CalculationManualRecalc v)
	, maybeToAttr toAttrFrStr "EnableIteration" (gmr'CalculationEnableIteration v)
	, maybeToAttr toAttrFrStr "MaxIterations" (gmr'CalculationMaxIterations v)
	, maybeToAttr toAttrFrStr "IterationTolerance" (gmr'CalculationIterationTolerance v)
	]
instance XmlContent Gmr'Attribute where
    fromElem (CElem (Elem "gmr:Attribute" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (Just (Gmr'Attribute a b c), rest))
	      (fromElem cb))
	   (fromElem ca))
	(fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Attribute a b c) =
	[CElem (Elem "gmr:Attribute" [] (maybe [] toElem a ++
					 maybe [] toElem b ++ maybe [] toElem c))]
instance XmlContent Gmr'Item where
    fromElem (CElem (Elem "gmr:Item" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (Just (Gmr'Item a b c), rest))
	      (fromElem cb))
	   (fromElem ca))
	(definite fromElem "<gmr:name>" "gmr:Item" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Item a b c) =
	[CElem (Elem "gmr:Item" [] (toElem a ++ maybe [] toElem b ++
				    maybe [] toElem c))]
instance XmlContent Gmr'SheetName where
    fromElem (CElem (Elem "gmr:SheetName" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'SheetName a), rest))
	(definite fromText "text" "gmr:SheetName" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'SheetName a) =
	[CElem (Elem "gmr:SheetName" [] (toText a))]
instance XmlContent Gmr'Sheet where
    fromElem (CElem (Elem "gmr:Sheet" as c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (\(g,cg)->
			     (\(h,ch)->
				(\(i,ci)->
				   (\(j,cj)->
				      (\(k,ck)->
					 (\(l,cl)->
					    (\(m,cm)->
					       (\(n,cn)->
						  (\(o,co)->
						     (\(p,cp)->
							(Just (Gmr'Sheet (fromAttrs as) a b c d e f
											g h i j k l
											m n o
											p), rest))
						     (many fromElem co))
						  (many fromElem cn))
					       (definite fromElem "<gmr:SheetLayout>" "gmr:Sheet" cm))
					    (fromElem cl))
					 (definite fromElem "<gmr:Cells>" "gmr:Sheet" ck))
				      (fromElem cj))
				   (definite fromElem "<gmr:Selections>" "gmr:Sheet" ci))
				(definite fromElem "<gmr:Rows>" "gmr:Sheet" ch))
			     (definite fromElem "<gmr:Cols>" "gmr:Sheet" cg))
			  (definite fromElem "<gmr:Styles>" "gmr:Sheet" cf))
		       (fromElem ce))
		    (many fromElem cd))
		 (definite fromElem "<gmr:Zoom>" "gmr:Sheet" cc))
	      (fromElem cb))
	   (fromElem ca))
	(definite fromElem "<gmr:Name>" "gmr:Sheet" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Sheet as a b c d e f g h i j k l m n o p) =
	[CElem (Elem "gmr:Sheet" (toAttrs as) (toElem a ++
					       maybe [] toElem b ++ maybe [] toElem c ++ toElem d ++
					       concatMap toElem e ++ maybe [] toElem f ++ toElem g
					       ++ toElem h ++ toElem i ++ toElem j ++
					       maybe [] toElem k ++ toElem l ++ maybe [] toElem m ++
					       toElem n ++ concatMap toElem o ++
					       concatMap toElem p))]
instance XmlAttributes Gmr'Sheet_Attrs where
    fromAttrs as =
	Gmr'Sheet_Attrs
	  { gmr'SheetDisplayFormulas = definiteA fromAttrToStr "gmr:Sheet" "DisplayFormulas" as
	  , gmr'SheetHideZero = definiteA fromAttrToStr "gmr:Sheet" "HideZero" as
	  , gmr'SheetHideGrid = definiteA fromAttrToStr "gmr:Sheet" "HideGrid" as
	  , gmr'SheetHideColHeader = definiteA fromAttrToStr "gmr:Sheet" "HideColHeader" as
	  , gmr'SheetHideRowHeader = definiteA fromAttrToStr "gmr:Sheet" "HideRowHeader" as
	  , gmr'SheetDisplayOutlines = definiteA fromAttrToStr "gmr:Sheet" "DisplayOutlines" as
	  , gmr'SheetOutlineSymbolsBelow = definiteA fromAttrToStr "gmr:Sheet" "OutlineSymbolsBelow" as
	  , gmr'SheetOutlineSymbolsRight = definiteA fromAttrToStr "gmr:Sheet" "OutlineSymbolsRight" as
	  , gmr'SheetTabColor = possibleA fromAttrToStr "TabColor" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "DisplayFormulas" (gmr'SheetDisplayFormulas v)
	, toAttrFrStr "HideZero" (gmr'SheetHideZero v)
	, toAttrFrStr "HideGrid" (gmr'SheetHideGrid v)
	, toAttrFrStr "HideColHeader" (gmr'SheetHideColHeader v)
	, toAttrFrStr "HideRowHeader" (gmr'SheetHideRowHeader v)
	, toAttrFrStr "DisplayOutlines" (gmr'SheetDisplayOutlines v)
	, toAttrFrStr "OutlineSymbolsBelow" (gmr'SheetOutlineSymbolsBelow v)
	, toAttrFrStr "OutlineSymbolsRight" (gmr'SheetOutlineSymbolsRight v)
	, maybeToAttr toAttrFrStr "TabColor" (gmr'SheetTabColor v)
	]
instance XmlContent Gmr'name where
    fromElem (CElem (Elem "gmr:name" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'name a), rest))
	(definite fromText "text" "gmr:name" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'name a) =
	[CElem (Elem "gmr:name" [] (toText a))]
instance XmlContent Gmr'type where
    fromElem (CElem (Elem "gmr:type" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'type a), rest))
	(definite fromText "text" "gmr:type" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'type a) =
	[CElem (Elem "gmr:type" [] (toText a))]
instance XmlContent Gmr'value where
    fromElem (CElem (Elem "gmr:value" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'value a), rest))
	(definite fromText "text" "gmr:value" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'value a) =
	[CElem (Elem "gmr:value" [] (toText a))]
instance XmlContent Gmr'val_string where
    fromElem (CElem (Elem "gmr:val-string" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'val_string a), rest))
	(definite fromText "text" "gmr:val-string" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'val_string a) =
	[CElem (Elem "gmr:val-string" [] (toText a))]
instance XmlContent Gmr'val_int where
    fromElem (CElem (Elem "gmr:val-int" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'val_int a), rest))
	(definite fromText "text" "gmr:val-int" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'val_int a) =
	[CElem (Elem "gmr:val-int" [] (toText a))]
instance XmlContent Gmr'Name where
    fromElem (CElem (Elem "gmr:Name" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Name a), rest))
	(definite fromText "text" "gmr:Name" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Name a) =
	[CElem (Elem "gmr:Name" [] (toText a))]
instance XmlContent Gmr'MaxCol where
    fromElem (CElem (Elem "gmr:MaxCol" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'MaxCol a), rest))
	(definite fromText "text" "gmr:MaxCol" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'MaxCol a) =
	[CElem (Elem "gmr:MaxCol" [] (toText a))]
instance XmlContent Gmr'MaxRow where
    fromElem (CElem (Elem "gmr:MaxRow" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'MaxRow a), rest))
	(definite fromText "text" "gmr:MaxRow" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'MaxRow a) =
	[CElem (Elem "gmr:MaxRow" [] (toText a))]
instance XmlContent Gmr'Zoom where
    fromElem (CElem (Elem "gmr:Zoom" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Zoom a), rest))
	(definite fromText "text" "gmr:Zoom" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Zoom a) =
	[CElem (Elem "gmr:Zoom" [] (toText a))]
instance XmlContent Gmr'PrintInformation where
    fromElem (CElem (Elem "gmr:PrintInformation" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (\(g,cg)->
			     (\(h,ch)->
				(\(i,ci)->
				   (\(j,cj)->
				      (\(k,ck)->
					 (\(l,cl)->
					    (\(m,cm)->
					       (\(n,cn)->
						  (\(o,co)->
						     (\(p,cp)->
							(Just (Gmr'PrintInformation a b c d e f g h
										    i j k l m n o
										    p), rest))
						     (fromElem co))
						  (definite fromElem "<gmr:Footer>" "gmr:PrintInformation" cn))
					       (definite fromElem "<gmr:Header>" "gmr:PrintInformation" cm))
					    (definite fromElem "<gmr:orientation>" "gmr:PrintInformation" cl))
					 (definite fromElem "<gmr:order>" "gmr:PrintInformation" ck))
				      (fromElem cj))
				   (fromElem ci))
				(definite fromElem "<gmr:titles>" "gmr:PrintInformation" ch))
			     (definite fromElem "<gmr:draft>" "gmr:PrintInformation" cg))
			  (definite fromElem "<gmr:monochrome>" "gmr:PrintInformation" cf))
		       (definite fromElem "<gmr:even_if_only_styles>" "gmr:PrintInformation" ce))
		    (definite fromElem "<gmr:grid>" "gmr:PrintInformation" cd))
		 (definite fromElem "<gmr:hcenter>" "gmr:PrintInformation" cc))
	      (definite fromElem "<gmr:vcenter>" "gmr:PrintInformation" cb))
	   (definite fromElem "<gmr:Scale>" "gmr:PrintInformation" ca))
	(definite fromElem "<gmr:Margins>" "gmr:PrintInformation" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'PrintInformation a b c d e f g h i j k l m n o p) =
	[CElem (Elem "gmr:PrintInformation" [] (toElem a ++ toElem b ++
						toElem c ++ toElem d ++ toElem e ++ toElem f ++
						toElem g ++ toElem h ++ toElem i ++
						maybe [] toElem j ++ maybe [] toElem k ++ toElem l
						++ toElem m ++ toElem n ++ toElem o ++
						maybe [] toElem p))]
instance XmlContent Gmr'Styles where
    fromElem (CElem (Elem "gmr:Styles" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Styles a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Styles a) =
	[CElem (Elem "gmr:Styles" [] (concatMap toElem a))]
instance XmlContent Gmr'Cols where
    fromElem (CElem (Elem "gmr:Cols" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Cols (fromAttrs as) a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Cols as a) =
	[CElem (Elem "gmr:Cols" (toAttrs as) (concatMap toElem a))]
instance XmlAttributes Gmr'Cols_Attrs where
    fromAttrs as =
	Gmr'Cols_Attrs
	  { gmr'ColsDefaultSizePts = definiteA fromAttrToStr "gmr:Cols" "DefaultSizePts" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "DefaultSizePts" (gmr'ColsDefaultSizePts v)
	]
instance XmlContent Gmr'Rows where
    fromElem (CElem (Elem "gmr:Rows" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Rows (fromAttrs as) a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Rows as a) =
	[CElem (Elem "gmr:Rows" (toAttrs as) (concatMap toElem a))]
instance XmlAttributes Gmr'Rows_Attrs where
    fromAttrs as =
	Gmr'Rows_Attrs
	  { gmr'RowsDefaultSizePts = definiteA fromAttrToStr "gmr:Rows" "DefaultSizePts" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "DefaultSizePts" (gmr'RowsDefaultSizePts v)
	]
instance XmlContent Gmr'Selections where
    fromElem (CElem (Elem "gmr:Selections" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Selections (fromAttrs as) a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Selections as a) =
	[CElem (Elem "gmr:Selections" (toAttrs as) (concatMap toElem a))]
instance XmlAttributes Gmr'Selections_Attrs where
    fromAttrs as =
	Gmr'Selections_Attrs
	  { gmr'SelectionsCursorCol = definiteA fromAttrToStr "gmr:Selections" "CursorCol" as
	  , gmr'SelectionsCursorRow = definiteA fromAttrToStr "gmr:Selections" "CursorRow" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "CursorCol" (gmr'SelectionsCursorCol v)
	, toAttrFrStr "CursorRow" (gmr'SelectionsCursorRow v)
	]
instance XmlContent Gmr'Objects where
    fromElem (CElem (Elem "gmr:Objects" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (\(g,cg)->
			     (Just (Gmr'Objects a b c d e f g), rest))
			  (many fromElem cf))
		       (many fromElem ce))
		    (many fromElem cd))
		 (many fromElem cc))
	      (many fromElem cb))
	   (many fromElem ca))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Objects a b c d e f g) =
	[CElem (Elem "gmr:Objects" [] (concatMap toElem a ++
				       concatMap toElem b ++ concatMap toElem c ++
				       concatMap toElem d ++ concatMap toElem e ++
				       concatMap toElem f ++ concatMap toElem g))]
instance XmlContent Gmr'Cells where
    fromElem (CElem (Elem "gmr:Cells" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Cells a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Cells a) =
	[CElem (Elem "gmr:Cells" [] (concatMap toElem a))]
instance XmlContent Gmr'MergedRegions where
    fromElem (CElem (Elem "gmr:MergedRegions" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'MergedRegions a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'MergedRegions a) =
	[CElem (Elem "gmr:MergedRegions" [] (concatMap toElem a))]
instance XmlContent Gmr'Solver where
    fromElem (CElem (Elem "gmr:Solver" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Solver (fromAttrs as) a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Solver as a) =
	[CElem (Elem "gmr:Solver" (toAttrs as) (concatMap toElem a))]
instance XmlAttributes Gmr'Solver_Attrs where
    fromAttrs as =
	Gmr'Solver_Attrs
	  { gmr'SolverTargetCol = possibleA fromAttrToStr "TargetCol" as
	  , gmr'SolverTargetRow = possibleA fromAttrToStr "TargetRow" as
	  , gmr'SolverProblemType = definiteA fromAttrToStr "gmr:Solver" "ProblemType" as
	  , gmr'SolverInputs = definiteA fromAttrToStr "gmr:Solver" "Inputs" as
	  , gmr'SolverMaxTime = possibleA fromAttrToStr "MaxTime" as
	  , gmr'SolverMaxIter = possibleA fromAttrToStr "MaxIter" as
	  , gmr'SolverNonNeg = possibleA fromAttrToStr "NonNeg" as
	  , gmr'SolverDiscr = possibleA fromAttrToStr "Discr" as
	  , gmr'SolverAutoScale = possibleA fromAttrToStr "AutoScale" as
	  , gmr'SolverShowIter = possibleA fromAttrToStr "ShowIter" as
	  , gmr'SolverAnswerR = possibleA fromAttrToStr "AnswerR" as
	  , gmr'SolverSensitivityR = possibleA fromAttrToStr "SensitivityR" as
	  , gmr'SolverLimitsR = possibleA fromAttrToStr "LimitsR" as
	  , gmr'SolverPerformR = possibleA fromAttrToStr "PerformR" as
	  , gmr'SolverProgramR = possibleA fromAttrToStr "ProgramR" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "TargetCol" (gmr'SolverTargetCol v)
	, maybeToAttr toAttrFrStr "TargetRow" (gmr'SolverTargetRow v)
	, toAttrFrStr "ProblemType" (gmr'SolverProblemType v)
	, toAttrFrStr "Inputs" (gmr'SolverInputs v)
	, maybeToAttr toAttrFrStr "MaxTime" (gmr'SolverMaxTime v)
	, maybeToAttr toAttrFrStr "MaxIter" (gmr'SolverMaxIter v)
	, maybeToAttr toAttrFrStr "NonNeg" (gmr'SolverNonNeg v)
	, maybeToAttr toAttrFrStr "Discr" (gmr'SolverDiscr v)
	, maybeToAttr toAttrFrStr "AutoScale" (gmr'SolverAutoScale v)
	, maybeToAttr toAttrFrStr "ShowIter" (gmr'SolverShowIter v)
	, maybeToAttr toAttrFrStr "AnswerR" (gmr'SolverAnswerR v)
	, maybeToAttr toAttrFrStr "SensitivityR" (gmr'SolverSensitivityR v)
	, maybeToAttr toAttrFrStr "LimitsR" (gmr'SolverLimitsR v)
	, maybeToAttr toAttrFrStr "PerformR" (gmr'SolverPerformR v)
	, maybeToAttr toAttrFrStr "ProgramR" (gmr'SolverProgramR v)
	]
instance XmlContent Gmr'Scenarios where
    fromElem (CElem (Elem "gmr:Scenarios" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Scenarios a), rest))
	(definite fromText "text" "gmr:Scenarios" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Scenarios a) =
	[CElem (Elem "gmr:Scenarios" [] (toText a))]
instance XmlContent Gmr'SheetLayout where
    fromElem (CElem (Elem "gmr:SheetLayout" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'SheetLayout (fromAttrs as) a), rest))
	(fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'SheetLayout as a) =
	[CElem (Elem "gmr:SheetLayout" (toAttrs as) (maybe [] toElem a))]
instance XmlAttributes Gmr'SheetLayout_Attrs where
    fromAttrs as =
	Gmr'SheetLayout_Attrs
	  { gmr'SheetLayoutTopLeft = definiteA fromAttrToStr "gmr:SheetLayout" "TopLeft" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "TopLeft" (gmr'SheetLayoutTopLeft v)
	]
instance XmlContent Gmr'Margins where
    fromElem (CElem (Elem "gmr:Margins" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (Just (Gmr'Margins a b c d e f), rest))
		       (definite fromElem "<gmr:footer>" "gmr:Margins" ce))
		    (definite fromElem "<gmr:header>" "gmr:Margins" cd))
		 (definite fromElem "<gmr:right>" "gmr:Margins" cc))
	      (definite fromElem "<gmr:left>" "gmr:Margins" cb))
	   (definite fromElem "<gmr:bottom>" "gmr:Margins" ca))
	(definite fromElem "<gmr:top>" "gmr:Margins" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Margins a b c d e f) =
	[CElem (Elem "gmr:Margins" [] (toElem a ++ toElem b ++ toElem c ++
				       toElem d ++ toElem e ++ toElem f))]
instance XmlContent Gmr'Scale where
    fromElem (CElem (Elem "gmr:Scale" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Scale" (toAttrs as) [])]
instance XmlAttributes Gmr'Scale where
    fromAttrs as =
	Gmr'Scale
	  { gmr'ScaleType = definiteA fromAttrToStr "gmr:Scale" "type" as
	  , gmr'ScalePercentage = possibleA fromAttrToStr "percentage" as
	  , gmr'ScaleCols = possibleA fromAttrToStr "cols" as
	  , gmr'ScaleRows = possibleA fromAttrToStr "rows" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "type" (gmr'ScaleType v)
	, maybeToAttr toAttrFrStr "percentage" (gmr'ScalePercentage v)
	, maybeToAttr toAttrFrStr "cols" (gmr'ScaleCols v)
	, maybeToAttr toAttrFrStr "rows" (gmr'ScaleRows v)
	]
instance XmlContent Gmr'vcenter where
    fromElem (CElem (Elem "gmr:vcenter" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:vcenter" (toAttrs as) [])]
instance XmlAttributes Gmr'vcenter where
    fromAttrs as =
	Gmr'vcenter
	  { gmr'vcenterValue = definiteA fromAttrToStr "gmr:vcenter" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'vcenterValue v)
	]
instance XmlContent Gmr'hcenter where
    fromElem (CElem (Elem "gmr:hcenter" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:hcenter" (toAttrs as) [])]
instance XmlAttributes Gmr'hcenter where
    fromAttrs as =
	Gmr'hcenter
	  { gmr'hcenterValue = definiteA fromAttrToStr "gmr:hcenter" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'hcenterValue v)
	]
instance XmlContent Gmr'grid where
    fromElem (CElem (Elem "gmr:grid" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:grid" (toAttrs as) [])]
instance XmlAttributes Gmr'grid where
    fromAttrs as =
	Gmr'grid
	  { gmr'gridValue = definiteA fromAttrToStr "gmr:grid" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'gridValue v)
	]
instance XmlContent Gmr'even_if_only_styles where
    fromElem (CElem (Elem "gmr:even_if_only_styles" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:even_if_only_styles" (toAttrs as) [])]
instance XmlAttributes Gmr'even_if_only_styles where
    fromAttrs as =
	Gmr'even_if_only_styles
	  { gmr'even_if_only_stylesValue = definiteA fromAttrToStr "gmr:even_if_only_styles" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'even_if_only_stylesValue v)
	]
instance XmlContent Gmr'monochrome where
    fromElem (CElem (Elem "gmr:monochrome" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:monochrome" (toAttrs as) [])]
instance XmlAttributes Gmr'monochrome where
    fromAttrs as =
	Gmr'monochrome
	  { gmr'monochromeValue = definiteA fromAttrToStr "gmr:monochrome" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'monochromeValue v)
	]
instance XmlContent Gmr'draft where
    fromElem (CElem (Elem "gmr:draft" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:draft" (toAttrs as) [])]
instance XmlAttributes Gmr'draft where
    fromAttrs as =
	Gmr'draft
	  { gmr'draftValue = definiteA fromAttrToStr "gmr:draft" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'draftValue v)
	]
instance XmlContent Gmr'titles where
    fromElem (CElem (Elem "gmr:titles" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:titles" (toAttrs as) [])]
instance XmlAttributes Gmr'titles where
    fromAttrs as =
	Gmr'titles
	  { gmr'titlesValue = definiteA fromAttrToStr "gmr:titles" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'titlesValue v)
	]
instance XmlContent Gmr'repeat_top where
    fromElem (CElem (Elem "gmr:repeat_top" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:repeat_top" (toAttrs as) [])]
instance XmlAttributes Gmr'repeat_top where
    fromAttrs as =
	Gmr'repeat_top
	  { gmr'repeat_topValue = definiteA fromAttrToStr "gmr:repeat_top" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'repeat_topValue v)
	]
instance XmlContent Gmr'repeat_left where
    fromElem (CElem (Elem "gmr:repeat_left" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:repeat_left" (toAttrs as) [])]
instance XmlAttributes Gmr'repeat_left where
    fromAttrs as =
	Gmr'repeat_left
	  { gmr'repeat_leftValue = definiteA fromAttrToStr "gmr:repeat_left" "value" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "value" (gmr'repeat_leftValue v)
	]
instance XmlContent Gmr'order where
    fromElem (CElem (Elem "gmr:order" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'order a), rest))
	(definite fromText "text" "gmr:order" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'order a) =
	[CElem (Elem "gmr:order" [] (toText a))]
instance XmlContent Gmr'orientation where
    fromElem (CElem (Elem "gmr:orientation" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'orientation a), rest))
	(definite fromText "text" "gmr:orientation" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'orientation a) =
	[CElem (Elem "gmr:orientation" [] (toText a))]
instance XmlContent Gmr'Header where
    fromElem (CElem (Elem "gmr:Header" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Header" (toAttrs as) [])]
instance XmlAttributes Gmr'Header where
    fromAttrs as =
	Gmr'Header
	  { gmr'HeaderLeft = definiteA fromAttrToStr "gmr:Header" "Left" as
	  , gmr'HeaderMiddle = definiteA fromAttrToStr "gmr:Header" "Middle" as
	  , gmr'HeaderRight = definiteA fromAttrToStr "gmr:Header" "Right" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Left" (gmr'HeaderLeft v)
	, toAttrFrStr "Middle" (gmr'HeaderMiddle v)
	, toAttrFrStr "Right" (gmr'HeaderRight v)
	]
instance XmlContent Gmr'Footer where
    fromElem (CElem (Elem "gmr:Footer" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Footer" (toAttrs as) [])]
instance XmlAttributes Gmr'Footer where
    fromAttrs as =
	Gmr'Footer
	  { gmr'FooterLeft = definiteA fromAttrToStr "gmr:Footer" "Left" as
	  , gmr'FooterMiddle = definiteA fromAttrToStr "gmr:Footer" "Middle" as
	  , gmr'FooterRight = definiteA fromAttrToStr "gmr:Footer" "Right" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Left" (gmr'FooterLeft v)
	, toAttrFrStr "Middle" (gmr'FooterMiddle v)
	, toAttrFrStr "Right" (gmr'FooterRight v)
	]
instance XmlContent Gmr'paper where
    fromElem (CElem (Elem "gmr:paper" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'paper a), rest))
	(definite fromText "text" "gmr:paper" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'paper a) =
	[CElem (Elem "gmr:paper" [] (toText a))]
instance XmlContent Gmr'StyleRegion where
    fromElem (CElem (Elem "gmr:StyleRegion" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'StyleRegion (fromAttrs as) a), rest))
	(definite fromElem "<gmr:Style>" "gmr:StyleRegion" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'StyleRegion as a) =
	[CElem (Elem "gmr:StyleRegion" (toAttrs as) (toElem a))]
instance XmlAttributes Gmr'StyleRegion_Attrs where
    fromAttrs as =
	Gmr'StyleRegion_Attrs
	  { gmr'StyleRegionStartCol = definiteA fromAttrToStr "gmr:StyleRegion" "startCol" as
	  , gmr'StyleRegionStartRow = definiteA fromAttrToStr "gmr:StyleRegion" "startRow" as
	  , gmr'StyleRegionEndCol = definiteA fromAttrToStr "gmr:StyleRegion" "endCol" as
	  , gmr'StyleRegionEndRow = definiteA fromAttrToStr "gmr:StyleRegion" "endRow" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "startCol" (gmr'StyleRegionStartCol v)
	, toAttrFrStr "startRow" (gmr'StyleRegionStartRow v)
	, toAttrFrStr "endCol" (gmr'StyleRegionEndCol v)
	, toAttrFrStr "endRow" (gmr'StyleRegionEndRow v)
	]
instance XmlContent Gmr'ColInfo where
    fromElem (CElem (Elem "gmr:ColInfo" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:ColInfo" (toAttrs as) [])]
instance XmlAttributes Gmr'ColInfo where
    fromAttrs as =
	Gmr'ColInfo
	  { gmr'ColInfoNo = definiteA fromAttrToStr "gmr:ColInfo" "No" as
	  , gmr'ColInfoUnit = definiteA fromAttrToStr "gmr:ColInfo" "Unit" as
	  , gmr'ColInfoMarginA = definiteA fromAttrToStr "gmr:ColInfo" "MarginA" as
	  , gmr'ColInfoMarginB = definiteA fromAttrToStr "gmr:ColInfo" "MarginB" as
	  , gmr'ColInfoHardSize = possibleA fromAttrToStr "HardSize" as
	  , gmr'ColInfoHidden = possibleA fromAttrToStr "Hidden" as
	  , gmr'ColInfoCollapsed = possibleA fromAttrToStr "Collapsed" as
	  , gmr'ColInfoOutlineLevel = possibleA fromAttrToStr "OutlineLevel" as
	  , gmr'ColInfoCount = possibleA fromAttrToStr "Count" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "No" (gmr'ColInfoNo v)
	, toAttrFrStr "Unit" (gmr'ColInfoUnit v)
	, toAttrFrStr "MarginA" (gmr'ColInfoMarginA v)
	, toAttrFrStr "MarginB" (gmr'ColInfoMarginB v)
	, maybeToAttr toAttrFrStr "HardSize" (gmr'ColInfoHardSize v)
	, maybeToAttr toAttrFrStr "Hidden" (gmr'ColInfoHidden v)
	, maybeToAttr toAttrFrStr "Collapsed" (gmr'ColInfoCollapsed v)
	, maybeToAttr toAttrFrStr "OutlineLevel" (gmr'ColInfoOutlineLevel v)
	, maybeToAttr toAttrFrStr "Count" (gmr'ColInfoCount v)
	]
instance XmlContent Gmr'RowInfo where
    fromElem (CElem (Elem "gmr:RowInfo" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:RowInfo" (toAttrs as) [])]
instance XmlAttributes Gmr'RowInfo where
    fromAttrs as =
	Gmr'RowInfo
	  { gmr'RowInfoNo = definiteA fromAttrToStr "gmr:RowInfo" "No" as
	  , gmr'RowInfoUnit = definiteA fromAttrToStr "gmr:RowInfo" "Unit" as
	  , gmr'RowInfoMarginA = definiteA fromAttrToStr "gmr:RowInfo" "MarginA" as
	  , gmr'RowInfoMarginB = definiteA fromAttrToStr "gmr:RowInfo" "MarginB" as
	  , gmr'RowInfoHardSize = possibleA fromAttrToStr "HardSize" as
	  , gmr'RowInfoHidden = possibleA fromAttrToStr "Hidden" as
	  , gmr'RowInfoCollapsed = possibleA fromAttrToStr "Collapsed" as
	  , gmr'RowInfoOutlineLevel = possibleA fromAttrToStr "OutlineLevel" as
	  , gmr'RowInfoCount = possibleA fromAttrToStr "Count" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "No" (gmr'RowInfoNo v)
	, toAttrFrStr "Unit" (gmr'RowInfoUnit v)
	, toAttrFrStr "MarginA" (gmr'RowInfoMarginA v)
	, toAttrFrStr "MarginB" (gmr'RowInfoMarginB v)
	, maybeToAttr toAttrFrStr "HardSize" (gmr'RowInfoHardSize v)
	, maybeToAttr toAttrFrStr "Hidden" (gmr'RowInfoHidden v)
	, maybeToAttr toAttrFrStr "Collapsed" (gmr'RowInfoCollapsed v)
	, maybeToAttr toAttrFrStr "OutlineLevel" (gmr'RowInfoOutlineLevel v)
	, maybeToAttr toAttrFrStr "Count" (gmr'RowInfoCount v)
	]
instance XmlContent Gmr'Selection where
    fromElem (CElem (Elem "gmr:Selection" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Selection" (toAttrs as) [])]
instance XmlAttributes Gmr'Selection where
    fromAttrs as =
	Gmr'Selection
	  { gmr'SelectionStartCol = definiteA fromAttrToStr "gmr:Selection" "startCol" as
	  , gmr'SelectionStartRow = definiteA fromAttrToStr "gmr:Selection" "startRow" as
	  , gmr'SelectionEndCol = definiteA fromAttrToStr "gmr:Selection" "endCol" as
	  , gmr'SelectionEndRow = definiteA fromAttrToStr "gmr:Selection" "endRow" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "startCol" (gmr'SelectionStartCol v)
	, toAttrFrStr "startRow" (gmr'SelectionStartRow v)
	, toAttrFrStr "endCol" (gmr'SelectionEndCol v)
	, toAttrFrStr "endRow" (gmr'SelectionEndRow v)
	]
instance XmlContent Gmr'SheetObjectBonobo where
    fromElem (CElem (Elem "gmr:SheetObjectBonobo" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:SheetObjectBonobo" (toAttrs as) [])]
instance XmlAttributes Gmr'SheetObjectBonobo where
    fromAttrs as =
	Gmr'SheetObjectBonobo
	  { gmr'SheetObjectBonoboObjectBound = definiteA fromAttrToStr "gmr:SheetObjectBonobo" "ObjectBound" as
	  , gmr'SheetObjectBonoboObjectOffset = definiteA fromAttrToStr "gmr:SheetObjectBonobo" "ObjectOffset" as
	  , gmr'SheetObjectBonoboObjectAnchorType = definiteA fromAttrToStr "gmr:SheetObjectBonobo" "ObjectAnchorType" as
	  , gmr'SheetObjectBonoboDirection = definiteA fromAttrToTyp "gmr:SheetObjectBonobo" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "ObjectBound" (gmr'SheetObjectBonoboObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'SheetObjectBonoboObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'SheetObjectBonoboObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'SheetObjectBonoboDirection v)
	]
instance XmlAttrType Gmr'SheetObjectBonobo_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'SheetObjectBonobo_Direction_MINUS
	    translate "0" = Just Gmr'SheetObjectBonobo_Direction_0
	    translate "1" = Just Gmr'SheetObjectBonobo_Direction_1
	    translate "16" = Just Gmr'SheetObjectBonobo_Direction_16
	    translate "17" = Just Gmr'SheetObjectBonobo_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'SheetObjectBonobo_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'SheetObjectBonobo_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'SheetObjectBonobo_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'SheetObjectBonobo_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'SheetObjectBonobo_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'CellComment where
    fromElem (CElem (Elem "gmr:CellComment" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:CellComment" (toAttrs as) [])]
instance XmlAttributes Gmr'CellComment where
    fromAttrs as =
	Gmr'CellComment
	  { gmr'CellCommentAuthor = definiteA fromAttrToStr "gmr:CellComment" "Author" as
	  , gmr'CellCommentText = definiteA fromAttrToStr "gmr:CellComment" "Text" as
	  , gmr'CellCommentObjectBound = definiteA fromAttrToStr "gmr:CellComment" "ObjectBound" as
	  , gmr'CellCommentObjectOffset = definiteA fromAttrToStr "gmr:CellComment" "ObjectOffset" as
	  , gmr'CellCommentObjectAnchorType = definiteA fromAttrToStr "gmr:CellComment" "ObjectAnchorType" as
	  , gmr'CellCommentDirection = definiteA fromAttrToTyp "gmr:CellComment" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Author" (gmr'CellCommentAuthor v)
	, toAttrFrStr "Text" (gmr'CellCommentText v)
	, toAttrFrStr "ObjectBound" (gmr'CellCommentObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'CellCommentObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'CellCommentObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'CellCommentDirection v)
	]
instance XmlAttrType Gmr'CellComment_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'CellComment_Direction_MINUS
	    translate "0" = Just Gmr'CellComment_Direction_0
	    translate "1" = Just Gmr'CellComment_Direction_1
	    translate "16" = Just Gmr'CellComment_Direction_16
	    translate "17" = Just Gmr'CellComment_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'CellComment_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'CellComment_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'CellComment_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'CellComment_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'CellComment_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'SheetObjectFilled where
    fromElem (CElem (Elem "gmr:SheetObjectFilled" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:SheetObjectFilled" (toAttrs as) [])]
instance XmlAttributes Gmr'SheetObjectFilled where
    fromAttrs as =
	Gmr'SheetObjectFilled
	  { gmr'SheetObjectFilledOutlineColor = definiteA fromAttrToStr "gmr:SheetObjectFilled" "OutlineColor" as
	  , gmr'SheetObjectFilledFillColor = definiteA fromAttrToStr "gmr:SheetObjectFilled" "FillColor" as
	  , gmr'SheetObjectFilledType = definiteA fromAttrToTyp "gmr:SheetObjectFilled" "Type" as
	  , gmr'SheetObjectFilledWidth = definiteA fromAttrToStr "gmr:SheetObjectFilled" "Width" as
	  , gmr'SheetObjectFilledArrowShapeA = possibleA fromAttrToStr "ArrowShapeA" as
	  , gmr'SheetObjectFilledArrowShapeB = possibleA fromAttrToStr "ArrowShapeB" as
	  , gmr'SheetObjectFilledArrowShapeC = possibleA fromAttrToStr "ArrowShapeC" as
	  , gmr'SheetObjectFilledObjectBound = definiteA fromAttrToStr "gmr:SheetObjectFilled" "ObjectBound" as
	  , gmr'SheetObjectFilledObjectOffset = definiteA fromAttrToStr "gmr:SheetObjectFilled" "ObjectOffset" as
	  , gmr'SheetObjectFilledObjectAnchorType = definiteA fromAttrToStr "gmr:SheetObjectFilled" "ObjectAnchorType" as
	  , gmr'SheetObjectFilledDirection = definiteA fromAttrToTyp "gmr:SheetObjectFilled" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "OutlineColor" (gmr'SheetObjectFilledOutlineColor v)
	, toAttrFrStr "FillColor" (gmr'SheetObjectFilledFillColor v)
	, toAttrFrTyp "Type" (gmr'SheetObjectFilledType v)
	, toAttrFrStr "Width" (gmr'SheetObjectFilledWidth v)
	, maybeToAttr toAttrFrStr "ArrowShapeA" (gmr'SheetObjectFilledArrowShapeA v)
	, maybeToAttr toAttrFrStr "ArrowShapeB" (gmr'SheetObjectFilledArrowShapeB v)
	, maybeToAttr toAttrFrStr "ArrowShapeC" (gmr'SheetObjectFilledArrowShapeC v)
	, toAttrFrStr "ObjectBound" (gmr'SheetObjectFilledObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'SheetObjectFilledObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'SheetObjectFilledObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'SheetObjectFilledDirection v)
	]
instance XmlAttrType Gmr'SheetObjectFilled_Type where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "1" = Just Gmr'SheetObjectFilled_Type_1
	    translate "2" = Just Gmr'SheetObjectFilled_Type_2
	    translate "101" = Just Gmr'SheetObjectFilled_Type_101
	    translate "102" = Just Gmr'SheetObjectFilled_Type_102
	    translate _ = Nothing
    toAttrFrTyp n Gmr'SheetObjectFilled_Type_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'SheetObjectFilled_Type_2 = Just (n, str2attr "2")
    toAttrFrTyp n Gmr'SheetObjectFilled_Type_101 = Just (n, str2attr "101")
    toAttrFrTyp n Gmr'SheetObjectFilled_Type_102 = Just (n, str2attr "102")
instance XmlAttrType Gmr'SheetObjectFilled_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'SheetObjectFilled_Direction_MINUS
	    translate "0" = Just Gmr'SheetObjectFilled_Direction_0
	    translate "1" = Just Gmr'SheetObjectFilled_Direction_1
	    translate "16" = Just Gmr'SheetObjectFilled_Direction_16
	    translate "17" = Just Gmr'SheetObjectFilled_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'SheetObjectFilled_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'SheetObjectFilled_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'SheetObjectFilled_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'SheetObjectFilled_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'SheetObjectFilled_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'Button where
    fromElem (CElem (Elem "gmr:Button" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Button" (toAttrs as) [])]
instance XmlAttributes Gmr'Button where
    fromAttrs as =
	Gmr'Button
	  { gmr'ButtonLabel = definiteA fromAttrToStr "gmr:Button" "Label" as
	  , gmr'ButtonObjectBound = definiteA fromAttrToStr "gmr:Button" "ObjectBound" as
	  , gmr'ButtonObjectOffset = definiteA fromAttrToStr "gmr:Button" "ObjectOffset" as
	  , gmr'ButtonObjectAnchorType = definiteA fromAttrToStr "gmr:Button" "ObjectAnchorType" as
	  , gmr'ButtonDirection = definiteA fromAttrToTyp "gmr:Button" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Label" (gmr'ButtonLabel v)
	, toAttrFrStr "ObjectBound" (gmr'ButtonObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'ButtonObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'ButtonObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'ButtonDirection v)
	]
instance XmlAttrType Gmr'Button_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'Button_Direction_MINUS
	    translate "0" = Just Gmr'Button_Direction_0
	    translate "1" = Just Gmr'Button_Direction_1
	    translate "16" = Just Gmr'Button_Direction_16
	    translate "17" = Just Gmr'Button_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'Button_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'Button_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'Button_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'Button_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'Button_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'Checkbox where
    fromElem (CElem (Elem "gmr:Checkbox" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Checkbox" (toAttrs as) [])]
instance XmlAttributes Gmr'Checkbox where
    fromAttrs as =
	Gmr'Checkbox
	  { gmr'CheckboxLabel = definiteA fromAttrToStr "gmr:Checkbox" "Label" as
	  , gmr'CheckboxValue = definiteA fromAttrToStr "gmr:Checkbox" "Value" as
	  , gmr'CheckboxInput = definiteA fromAttrToStr "gmr:Checkbox" "Input" as
	  , gmr'CheckboxObjectBound = definiteA fromAttrToStr "gmr:Checkbox" "ObjectBound" as
	  , gmr'CheckboxObjectOffset = definiteA fromAttrToStr "gmr:Checkbox" "ObjectOffset" as
	  , gmr'CheckboxObjectAnchorType = definiteA fromAttrToStr "gmr:Checkbox" "ObjectAnchorType" as
	  , gmr'CheckboxDirection = definiteA fromAttrToTyp "gmr:Checkbox" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Label" (gmr'CheckboxLabel v)
	, toAttrFrStr "Value" (gmr'CheckboxValue v)
	, toAttrFrStr "Input" (gmr'CheckboxInput v)
	, toAttrFrStr "ObjectBound" (gmr'CheckboxObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'CheckboxObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'CheckboxObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'CheckboxDirection v)
	]
instance XmlAttrType Gmr'Checkbox_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'Checkbox_Direction_MINUS
	    translate "0" = Just Gmr'Checkbox_Direction_0
	    translate "1" = Just Gmr'Checkbox_Direction_1
	    translate "16" = Just Gmr'Checkbox_Direction_16
	    translate "17" = Just Gmr'Checkbox_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'Checkbox_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'Checkbox_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'Checkbox_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'Checkbox_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'Checkbox_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'Frame where
    fromElem (CElem (Elem "gmr:Frame" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Frame" (toAttrs as) [])]
instance XmlAttributes Gmr'Frame where
    fromAttrs as =
	Gmr'Frame
	  { gmr'FrameLabel = definiteA fromAttrToStr "gmr:Frame" "Label" as
	  , gmr'FrameObjectBound = definiteA fromAttrToStr "gmr:Frame" "ObjectBound" as
	  , gmr'FrameObjectOffset = definiteA fromAttrToStr "gmr:Frame" "ObjectOffset" as
	  , gmr'FrameObjectAnchorType = definiteA fromAttrToStr "gmr:Frame" "ObjectAnchorType" as
	  , gmr'FrameDirection = definiteA fromAttrToTyp "gmr:Frame" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Label" (gmr'FrameLabel v)
	, toAttrFrStr "ObjectBound" (gmr'FrameObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'FrameObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'FrameObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'FrameDirection v)
	]
instance XmlAttrType Gmr'Frame_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'Frame_Direction_MINUS
	    translate "0" = Just Gmr'Frame_Direction_0
	    translate "1" = Just Gmr'Frame_Direction_1
	    translate "16" = Just Gmr'Frame_Direction_16
	    translate "17" = Just Gmr'Frame_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'Frame_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'Frame_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'Frame_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'Frame_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'Frame_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'Label where
    fromElem (CElem (Elem "gmr:Label" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Label" (toAttrs as) [])]
instance XmlAttributes Gmr'Label where
    fromAttrs as =
	Gmr'Label
	  { gmr'LabelLabel = definiteA fromAttrToStr "gmr:Label" "Label" as
	  , gmr'LabelObjectBound = definiteA fromAttrToStr "gmr:Label" "ObjectBound" as
	  , gmr'LabelObjectOffset = definiteA fromAttrToStr "gmr:Label" "ObjectOffset" as
	  , gmr'LabelObjectAnchorType = definiteA fromAttrToStr "gmr:Label" "ObjectAnchorType" as
	  , gmr'LabelDirection = definiteA fromAttrToTyp "gmr:Label" "Direction" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Label" (gmr'LabelLabel v)
	, toAttrFrStr "ObjectBound" (gmr'LabelObjectBound v)
	, toAttrFrStr "ObjectOffset" (gmr'LabelObjectOffset v)
	, toAttrFrStr "ObjectAnchorType" (gmr'LabelObjectAnchorType v)
	, toAttrFrTyp "Direction" (gmr'LabelDirection v)
	]
instance XmlAttrType Gmr'Label_Direction where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "-1" = Just Gmr'Label_Direction_MINUS
	    translate "0" = Just Gmr'Label_Direction_0
	    translate "1" = Just Gmr'Label_Direction_1
	    translate "16" = Just Gmr'Label_Direction_16
	    translate "17" = Just Gmr'Label_Direction_17
	    translate _ = Nothing
    toAttrFrTyp n Gmr'Label_Direction_MINUS = Just (n, str2attr "-1")
    toAttrFrTyp n Gmr'Label_Direction_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'Label_Direction_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'Label_Direction_16 = Just (n, str2attr "16")
    toAttrFrTyp n Gmr'Label_Direction_17 = Just (n, str2attr "17")
instance XmlContent Gmr'Cell where
    fromElem (CElem (Elem "gmr:Cell" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Cell (fromAttrs as) a), rest))
	(definite fromText "text" "gmr:Cell" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Cell as a) =
	[CElem (Elem "gmr:Cell" (toAttrs as) (toText a))]
instance XmlAttributes Gmr'Cell_Attrs where
    fromAttrs as =
	Gmr'Cell_Attrs
	  { gmr'CellCol = definiteA fromAttrToStr "gmr:Cell" "Col" as
	  , gmr'CellRow = definiteA fromAttrToStr "gmr:Cell" "Row" as
	  , gmr'CellExprID = possibleA fromAttrToStr "ExprID" as
	  , gmr'CellValueType = possibleA fromAttrToTyp "ValueType" as
	  , gmr'CellValueFormat = possibleA fromAttrToStr "ValueFormat" as
	  , gmr'CellCols = possibleA fromAttrToStr "Cols" as
	  , gmr'CellRows = possibleA fromAttrToStr "Rows" as
	  , gmr'CellAst = Nothing
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Col" (gmr'CellCol v)
	, toAttrFrStr "Row" (gmr'CellRow v)
	, maybeToAttr toAttrFrStr "ExprID" (gmr'CellExprID v)
	, maybeToAttr toAttrFrTyp "ValueType" (gmr'CellValueType v)
	, maybeToAttr toAttrFrStr "ValueFormat" (gmr'CellValueFormat v)
	, maybeToAttr toAttrFrStr "Cols" (gmr'CellCols v)
	, maybeToAttr toAttrFrStr "Rows" (gmr'CellRows v)
	-- maybeToAttr toAttrFrStr "ast" (gmr'CellAst v)
	]
instance XmlAttrType Gmr'Cell_ValueType where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "10" = Just Gmr'Cell_ValueType_10
	    translate "20" = Just Gmr'Cell_ValueType_20
	    translate "30" = Just Gmr'Cell_ValueType_30
	    translate "40" = Just Gmr'Cell_ValueType_40
	    translate "50" = Just Gmr'Cell_ValueType_50
	    translate "60" = Just Gmr'Cell_ValueType_60
	    translate "70" = Just Gmr'Cell_ValueType_70
	    translate "80" = Just Gmr'Cell_ValueType_80
	    translate _ = Nothing
    toAttrFrTyp n Gmr'Cell_ValueType_10 = Just (n, str2attr "10")
    toAttrFrTyp n Gmr'Cell_ValueType_20 = Just (n, str2attr "20")
    toAttrFrTyp n Gmr'Cell_ValueType_30 = Just (n, str2attr "30")
    toAttrFrTyp n Gmr'Cell_ValueType_40 = Just (n, str2attr "40")
    toAttrFrTyp n Gmr'Cell_ValueType_50 = Just (n, str2attr "50")
    toAttrFrTyp n Gmr'Cell_ValueType_60 = Just (n, str2attr "60")
    toAttrFrTyp n Gmr'Cell_ValueType_70 = Just (n, str2attr "70")
    toAttrFrTyp n Gmr'Cell_ValueType_80 = Just (n, str2attr "80")
instance XmlContent Gmr'Merge where
    fromElem (CElem (Elem "gmr:Merge" [] c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Merge a), rest))
	(definite fromText "text" "gmr:Merge" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Merge a) =
	[CElem (Elem "gmr:Merge" [] (toText a))]
instance XmlContent Gmr'Constr where
    fromElem (CElem (Elem "gmr:Constr" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Constr" (toAttrs as) [])]
instance XmlAttributes Gmr'Constr where
    fromAttrs as =
	Gmr'Constr
	  { gmr'ConstrLcol = definiteA fromAttrToStr "gmr:Constr" "Lcol" as
	  , gmr'ConstrLrow = definiteA fromAttrToStr "gmr:Constr" "Lrow" as
	  , gmr'ConstrRcol = definiteA fromAttrToStr "gmr:Constr" "Rcol" as
	  , gmr'ConstrRrow = definiteA fromAttrToStr "gmr:Constr" "Rrow" as
	  , gmr'ConstrCols = definiteA fromAttrToStr "gmr:Constr" "Cols" as
	  , gmr'ConstrRows = definiteA fromAttrToStr "gmr:Constr" "Rows" as
	  , gmr'ConstrType = definiteA fromAttrToTyp "gmr:Constr" "Type" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Lcol" (gmr'ConstrLcol v)
	, toAttrFrStr "Lrow" (gmr'ConstrLrow v)
	, toAttrFrStr "Rcol" (gmr'ConstrRcol v)
	, toAttrFrStr "Rrow" (gmr'ConstrRrow v)
	, toAttrFrStr "Cols" (gmr'ConstrCols v)
	, toAttrFrStr "Rows" (gmr'ConstrRows v)
	, toAttrFrTyp "Type" (gmr'ConstrType v)
	]
instance XmlAttrType Gmr'Constr_Type where
    fromAttrToTyp n (n',v)
	| n==n'     = translate (attr2str v)
	| otherwise = Nothing
      where translate "0" = Just Gmr'Constr_Type_0
	    translate "1" = Just Gmr'Constr_Type_1
	    translate "2" = Just Gmr'Constr_Type_2
	    translate "4" = Just Gmr'Constr_Type_4
	    translate "8" = Just Gmr'Constr_Type_8
	    translate "16" = Just Gmr'Constr_Type_16
	    translate _ = Nothing
    toAttrFrTyp n Gmr'Constr_Type_0 = Just (n, str2attr "0")
    toAttrFrTyp n Gmr'Constr_Type_1 = Just (n, str2attr "1")
    toAttrFrTyp n Gmr'Constr_Type_2 = Just (n, str2attr "2")
    toAttrFrTyp n Gmr'Constr_Type_4 = Just (n, str2attr "4")
    toAttrFrTyp n Gmr'Constr_Type_8 = Just (n, str2attr "8")
    toAttrFrTyp n Gmr'Constr_Type_16 = Just (n, str2attr "16")
instance XmlContent Gmr'FreezePanes where
    fromElem (CElem (Elem "gmr:FreezePanes" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:FreezePanes" (toAttrs as) [])]
instance XmlAttributes Gmr'FreezePanes where
    fromAttrs as =
	Gmr'FreezePanes
	  { gmr'FreezePanesFrozenTopLeft = definiteA fromAttrToStr "gmr:FreezePanes" "FrozenTopLeft" as
	  , gmr'FreezePanesUnfrozenTopLeft = definiteA fromAttrToStr "gmr:FreezePanes" "UnfrozenTopLeft" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "FrozenTopLeft" (gmr'FreezePanesFrozenTopLeft v)
	, toAttrFrStr "UnfrozenTopLeft" (gmr'FreezePanesUnfrozenTopLeft v)
	]
instance XmlContent Gmr'top where
    fromElem (CElem (Elem "gmr:top" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:top" (toAttrs as) [])]
instance XmlAttributes Gmr'top where
    fromAttrs as =
	Gmr'top
	  { gmr'topPoints = possibleA fromAttrToStr "Points" as
	  , gmr'topPrefUnit = possibleA fromAttrToStr "PrefUnit" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Points" (gmr'topPoints v)
	, maybeToAttr toAttrFrStr "PrefUnit" (gmr'topPrefUnit v)
	]
instance XmlContent Gmr'bottom where
    fromElem (CElem (Elem "gmr:bottom" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:bottom" (toAttrs as) [])]
instance XmlAttributes Gmr'bottom where
    fromAttrs as =
	Gmr'bottom
	  { gmr'bottomPoints = possibleA fromAttrToStr "Points" as
	  , gmr'bottomPrefUnit = possibleA fromAttrToStr "PrefUnit" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Points" (gmr'bottomPoints v)
	, maybeToAttr toAttrFrStr "PrefUnit" (gmr'bottomPrefUnit v)
	]
instance XmlContent Gmr'left where
    fromElem (CElem (Elem "gmr:left" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:left" (toAttrs as) [])]
instance XmlAttributes Gmr'left where
    fromAttrs as =
	Gmr'left
	  { gmr'leftPoints = possibleA fromAttrToStr "Points" as
	  , gmr'leftPrefUnit = possibleA fromAttrToStr "PrefUnit" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Points" (gmr'leftPoints v)
	, maybeToAttr toAttrFrStr "PrefUnit" (gmr'leftPrefUnit v)
	]
instance XmlContent Gmr'right where
    fromElem (CElem (Elem "gmr:right" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:right" (toAttrs as) [])]
instance XmlAttributes Gmr'right where
    fromAttrs as =
	Gmr'right
	  { gmr'rightPoints = possibleA fromAttrToStr "Points" as
	  , gmr'rightPrefUnit = possibleA fromAttrToStr "PrefUnit" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Points" (gmr'rightPoints v)
	, maybeToAttr toAttrFrStr "PrefUnit" (gmr'rightPrefUnit v)
	]
instance XmlContent Gmr'header where
    fromElem (CElem (Elem "gmr:header" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:header" (toAttrs as) [])]
instance XmlAttributes Gmr'header where
    fromAttrs as =
	Gmr'header
	  { gmr'headerPoints = possibleA fromAttrToStr "Points" as
	  , gmr'headerPrefUnit = possibleA fromAttrToStr "PrefUnit" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Points" (gmr'headerPoints v)
	, maybeToAttr toAttrFrStr "PrefUnit" (gmr'headerPrefUnit v)
	]
instance XmlContent Gmr'footer where
    fromElem (CElem (Elem "gmr:footer" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:footer" (toAttrs as) [])]
instance XmlAttributes Gmr'footer where
    fromAttrs as =
	Gmr'footer
	  { gmr'footerPoints = possibleA fromAttrToStr "Points" as
	  , gmr'footerPrefUnit = possibleA fromAttrToStr "PrefUnit" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "Points" (gmr'footerPoints v)
	, maybeToAttr toAttrFrStr "PrefUnit" (gmr'footerPrefUnit v)
	]
instance XmlContent Gmr'Style where
    fromElem (CElem (Elem "gmr:Style" as c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (Just (Gmr'Style (fromAttrs as) a b), rest))
	   (fromElem ca))
	(definite fromElem "<gmr:Font>" "gmr:Style" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Style as a b) =
	[CElem (Elem "gmr:Style" (toAttrs as) (toElem a ++
					       maybe [] toElem b))]
instance XmlAttributes Gmr'Style_Attrs where
    fromAttrs as =
	Gmr'Style_Attrs
	  { gmr'StyleHAlign = possibleA fromAttrToStr "HAlign" as
	  , gmr'StyleVAlign = possibleA fromAttrToStr "VAlign" as
	  , gmr'StyleWrapText = possibleA fromAttrToStr "WrapText" as
	  , gmr'StyleOrient = possibleA fromAttrToStr "Orient" as
	  , gmr'StyleShade = possibleA fromAttrToStr "Shade" as
	  , gmr'StyleIndent = possibleA fromAttrToStr "Indent" as
	  , gmr'StyleFore = possibleA fromAttrToStr "Fore" as
	  , gmr'StyleBack = possibleA fromAttrToStr "Back" as
	  , gmr'StylePatternColor = possibleA fromAttrToStr "PatternColor" as
	  , gmr'StyleLocked = possibleA fromAttrToStr "Locked" as
	  , gmr'StyleHidden = possibleA fromAttrToStr "Hidden" as
	  , gmr'StyleFormat = definiteA fromAttrToStr "gmr:Style" "Format" as
	  , gmr'StyleShrinkToFit = possibleA fromAttrToStr "ShrinkToFit" as
	  , gmr'StyleRotation = possibleA fromAttrToStr "Rotation" as
	  }
    toAttrs v = catMaybes 
	[ maybeToAttr toAttrFrStr "HAlign" (gmr'StyleHAlign v)
	, maybeToAttr toAttrFrStr "VAlign" (gmr'StyleVAlign v)
	, maybeToAttr toAttrFrStr "WrapText" (gmr'StyleWrapText v)
	, maybeToAttr toAttrFrStr "Orient" (gmr'StyleOrient v)
	, maybeToAttr toAttrFrStr "Shade" (gmr'StyleShade v)
	, maybeToAttr toAttrFrStr "Indent" (gmr'StyleIndent v)
	, maybeToAttr toAttrFrStr "Fore" (gmr'StyleFore v)
	, maybeToAttr toAttrFrStr "Back" (gmr'StyleBack v)
	, maybeToAttr toAttrFrStr "PatternColor" (gmr'StylePatternColor v)
	, maybeToAttr toAttrFrStr "Locked" (gmr'StyleLocked v)
	, maybeToAttr toAttrFrStr "Hidden" (gmr'StyleHidden v)
	, toAttrFrStr "Format" (gmr'StyleFormat v)
	, maybeToAttr toAttrFrStr "ShrinkToFit" (gmr'StyleShrinkToFit v)
	, maybeToAttr toAttrFrStr "Rotation" (gmr'StyleRotation v)
	]
instance XmlContent Gmr'Font where
    fromElem (CElem (Elem "gmr:Font" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Font (fromAttrs as) a), rest))
	(definite fromText "text" "gmr:Font" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Font as a) =
	[CElem (Elem "gmr:Font" (toAttrs as) (toText a))]
instance XmlAttributes Gmr'Font_Attrs where
    fromAttrs as =
	Gmr'Font_Attrs
	  { gmr'FontUnit = definiteA fromAttrToStr "gmr:Font" "Unit" as
	  , gmr'FontBold = definiteA fromAttrToStr "gmr:Font" "Bold" as
	  , gmr'FontItalic = definiteA fromAttrToStr "gmr:Font" "Italic" as
	  , gmr'FontUnderline = definiteA fromAttrToStr "gmr:Font" "Underline" as
	  , gmr'FontStrikeThrough = definiteA fromAttrToStr "gmr:Font" "StrikeThrough" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Unit" (gmr'FontUnit v)
	, toAttrFrStr "Bold" (gmr'FontBold v)
	, toAttrFrStr "Italic" (gmr'FontItalic v)
	, toAttrFrStr "Underline" (gmr'FontUnderline v)
	, toAttrFrStr "StrikeThrough" (gmr'FontStrikeThrough v)
	]
instance XmlContent Gmr'StyleBorder where
    fromElem (CElem (Elem "gmr:StyleBorder" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (Just (Gmr'StyleBorder a b c d e f), rest))
		       (definite fromElem "<gmr:Rev-Diagonal>" "gmr:StyleBorder" ce))
		    (definite fromElem "<gmr:Diagonal>" "gmr:StyleBorder" cd))
		 (definite fromElem "<gmr:Right>" "gmr:StyleBorder" cc))
	      (definite fromElem "<gmr:Left>" "gmr:StyleBorder" cb))
	   (definite fromElem "<gmr:Bottom>" "gmr:StyleBorder" ca))
	(definite fromElem "<gmr:Top>" "gmr:StyleBorder" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'StyleBorder a b c d e f) =
	[CElem (Elem "gmr:StyleBorder" [] (toElem a ++ toElem b ++ toElem c
					   ++ toElem d ++ toElem e ++ toElem f))]
instance XmlContent Gmr'Top where
    fromElem (CElem (Elem "gmr:Top" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Top" (toAttrs as) [])]
instance XmlAttributes Gmr'Top where
    fromAttrs as =
	Gmr'Top
	  { gmr'TopStyle = definiteA fromAttrToStr "gmr:Top" "Style" as
	  , gmr'TopColor = possibleA fromAttrToStr "Color" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Style" (gmr'TopStyle v)
	, maybeToAttr toAttrFrStr "Color" (gmr'TopColor v)
	]
instance XmlContent Gmr'Bottom where
    fromElem (CElem (Elem "gmr:Bottom" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Bottom" (toAttrs as) [])]
instance XmlAttributes Gmr'Bottom where
    fromAttrs as =
	Gmr'Bottom
	  { gmr'BottomStyle = definiteA fromAttrToStr "gmr:Bottom" "Style" as
	  , gmr'BottomColor = possibleA fromAttrToStr "Color" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Style" (gmr'BottomStyle v)
	, maybeToAttr toAttrFrStr "Color" (gmr'BottomColor v)
	]
instance XmlContent Gmr'Left where
    fromElem (CElem (Elem "gmr:Left" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Left" (toAttrs as) [])]
instance XmlAttributes Gmr'Left where
    fromAttrs as =
	Gmr'Left
	  { gmr'LeftStyle = definiteA fromAttrToStr "gmr:Left" "Style" as
	  , gmr'LeftColor = possibleA fromAttrToStr "Color" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Style" (gmr'LeftStyle v)
	, maybeToAttr toAttrFrStr "Color" (gmr'LeftColor v)
	]
instance XmlContent Gmr'Right where
    fromElem (CElem (Elem "gmr:Right" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Right" (toAttrs as) [])]
instance XmlAttributes Gmr'Right where
    fromAttrs as =
	Gmr'Right
	  { gmr'RightStyle = definiteA fromAttrToStr "gmr:Right" "Style" as
	  , gmr'RightColor = possibleA fromAttrToStr "Color" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Style" (gmr'RightStyle v)
	, maybeToAttr toAttrFrStr "Color" (gmr'RightColor v)
	]
instance XmlContent Gmr'Diagonal where
    fromElem (CElem (Elem "gmr:Diagonal" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Diagonal" (toAttrs as) [])]
instance XmlAttributes Gmr'Diagonal where
    fromAttrs as =
	Gmr'Diagonal
	  { gmr'DiagonalStyle = definiteA fromAttrToStr "gmr:Diagonal" "Style" as
	  , gmr'DiagonalColor = possibleA fromAttrToStr "Color" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Style" (gmr'DiagonalStyle v)
	, maybeToAttr toAttrFrStr "Color" (gmr'DiagonalColor v)
	]
instance XmlContent Gmr'Rev_Diagonal where
    fromElem (CElem (Elem "gmr:Rev-Diagonal" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem (CString _ s:rest) | all isSpace s = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "gmr:Rev-Diagonal" (toAttrs as) [])]
instance XmlAttributes Gmr'Rev_Diagonal where
    fromAttrs as =
	Gmr'Rev_Diagonal
	  { gmr'Rev_DiagonalStyle = definiteA fromAttrToStr "gmr:Rev-Diagonal" "Style" as
	  , gmr'Rev_DiagonalColor = possibleA fromAttrToStr "Color" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "Style" (gmr'Rev_DiagonalStyle v)
	, maybeToAttr toAttrFrStr "Color" (gmr'Rev_DiagonalColor v)
	]


{-Done-}
